#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <speedspeed>
#include <hamsandwich>

#define PLUGIN "Sprinting"
#define VERSION "1.0"
#define AUTHOR "R3X"

new const Float:fSprintingTime = 2.0;
new const Float:fRestingTime = 3.0;
new const Float:fSpeedUp = 100;

new Float:gfSpeedOffset[33];

new giWid[33];
new Float:gfSprint[33];
new Float:gfRest[33];

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_event("CurWeapon", "eventCurWeapon", "be", "1=1");
	RegisterHam(Ham_Spawn, "player", "fwHamSpawn", 1);
	register_forward(FM_PlayerPreThink, "fwPlayerPretThink", 1);
}

//SpeedSpeed
public speed_update(id){
	add_user_speed(id, gfSpeedOffset[id]);
}

public eventSpeedUp(id){
	new Float:fNow = get_gametime();
	
	if(fNow < gfRest[id]){
		set_hudmessage(255, 255, 255, -1.0, 0.3, 0, 0.0, 2.0);
		show_hudmessage(id, "Odpocznij chwile")
		return;
	}

	gfSpeedOffset[id] = fSpeedUp;
	update_user_speed(id);
	
	gfSprint[id] = fNow + fSprintingTime;
	
	set_hudmessage(255, 255, 255, -1.0, 0.3, 0, 0.0, 2.0);
	show_hudmessage(id, "Sprint!")
}
public eventSpeedDown(id){
	gfSpeedOffset[id] = 0.0;
	update_user_speed(id);
	
	new Float:fNow = get_gametime();
	gfRest[id] =  fNow + fRestingTime;
	
	set_hudmessage(255, 255, 255, -1.0, 0.3, 0, 0.0, 2.0);
	show_hudmessage(id, "Tyla")
}

public fwHamSpawn(id)
	gfSpeedOffset[id] = 0.0;
	
public eventCurWeapon(id){
	new wid = read_data(2);
	giWid[id] = wid;
}
public fwPlayerPretThink(id){
	if(!is_user_alive(id))
		return FMRES_IGNORED;
		
	new wid = giWid[id];
	new button = pev(id, pev_button) & IN_ATTACK2;
	new oldbuttons = pev(id, pev_oldbuttons)& IN_ATTACK2;
	
	if((button && !oldbuttons)){
		if(wid == CSW_KNIFE) 
			eventSpeedUp(id);
	}
	
	else if(gfSpeedOffset[id]){
		if((!button && oldbuttons) || wid != CSW_KNIFE || gfSprint[id] < get_gametime())
			eventSpeedDown(id);
	}
	
	
	return FMRES_IGNORED;
}